#!/usr/bin/perl 
#written 5/5/98 by chris@katipo.co.nz
#to insert,update and display client information
#updated by chris@katipo.co.nz
#to use Time::Sheeting 4/3/99
# updated to nicer look 23/3/99
# more cosmetics 3/5/99

use CGI;
use Time::Sheeting;
use Date::Manip;
use DBI;
use strict;
#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#Set up the DBI and connect to the database
my $dbh=&TimeConnect;
my $query= new CGI;

my $type=$query->param('type');
my $check=0;

print $query->header;
print $query->start_html(-title=>'Client list',
                         -bgcolor=>'White');
#print $query->dump;
#print $type;

#if type is insert we want to insert the data
if ($type eq 'insert' || $type eq 'update'){
  # get all the data from the form
  my $name=$query->param('name');
  my $po_box=$query->param('po_box');
  my $street=$query->param('street');
  my $suburb=$query->param('suburb');
  my $city=$query->param('city');
  my $phone=$query->param('phone');
  my $fax=$query->param('fax');
  my $url1=$query->param('url1');
  $url1=~ s/http:\/\///i;
  my $url2=$query->param('url2');
  $url2=~ s/http:\/\///i;
  my $url3=$query->param('url3');
  $url3=~ s/http:\/\///i;
  my $url4=$query->param('url4');
  $url4=~ s/http:\/\///i;
  my $maillist=$query->param('maillist');
  my $c1name=$query->param('c1name');
  my $c1phone=$query->param('c1phone');
  my $c1altphone=$query->param('c1altphone');
  my $c1email=$query->param('c1email');
  my $c2name=$query->param('c2name');
  my $c2phone=$query->param('c2phone');
  my $c2altphone=$query->param('c2altphone');
  my $c2email=$query->param('c2email');
  my $temp=&ParseDate('today');
  my $year=substr($temp,0,4);
  my $month=substr($temp,4,2,);
  my $day=substr($temp,6,2);
  $temp=join("-",$year,$month,$day); 
  my $putquery;
  if ($type eq 'insert'){
    $putquery=" Insert into client 
    (name,po_box,street,suburb,city,phone,fax,url1,url2,url3,url4,maillist,
    c1name,c1phone,c1altphone,c1email,c2name,c2phone,c2altphone,c2email,
    createdate,moddate)
    values
    ('$name','$po_box','$street','$suburb','$city','$phone','$fax',
    '$url1','$url2','$url3','$url4',$maillist,'$c1name','$c1phone',
    '$c1altphone','$c1email','$c2name','$c2phone','$c2altphone','$c2email',
    '$temp','$temp')";
  } else {

    my $num=$query->param('num');
    $putquery="Update client set name='$name',po_box='$po_box',street='$street',
    suburb='$suburb',city='$city',phone='$phone',fax='$fax',url1='$url1',
    url2='$url2',url3='$url3',url4='$url4',maillist=$maillist,c1name=
    '$c1name',c1phone='$c1phone',c1altphone='$c1altphone',c1email=
    '$c1email',c2name='$c2name',c2phone='$c2phone',c2altphone='$c2altphone',
    c2email='$c2email',moddate='$temp' where recordno='$num'";
  }   
    #insert delete projects that the client owns
    my $sth=$dbh->prepare("Select project from jobs group by project");
    $sth->execute;
    while (my $data=$sth->fetchrow_arrayref){
      my $temp=$query->param($$data[0]);
      if ($temp ne ''){
        #insert 
	my $sth3=$dbh->prepare("Select * from clientproj where clientname=
	'$name' and project='$temp'");
	$sth3->execute;
	if (my $dat=$sth3->fetchrow_arrayref){
	}else {
	my $sth2=$dbh->prepare("Insert into clientproj values ('$name','$temp')");
	$sth2->execute;
	$sth2->finish;
	}
	$sth3->finish;
      } else {
        #delete
	my $sth2=$dbh->prepare("Delete from clientproj where clientname=
	'$name' and project='$$data[0]'");
	$sth2->execute;
	$sth2->finish;
      }
    }

  

  my $sth=$dbh->prepare($putquery);
  $sth->execute;
  $sth->finish;
#  print $putquery;
} else {
  #script has been called to do a modification
  my $modify=$query->param('modify.x');
  my $add=$query->param('Add');
  if ($modify ne '' || $add ne ''){
#    print $query->dump;
    $check=1;
    my $num=$query->param('num');
    #get record from the database
    my $sth=$dbh->prepare("Select * from client where recordno = '$num'");
    $sth->execute;
    my $data=$sth->fetchrow_arrayref;
    $sth->finish;
    #get a list of all the projects
    $sth=$dbh->prepare("Select project from jobs group by project");
    $sth->execute;
    my $i=0;
    my @proj;
    while (my $data2=$sth->fetchrow_arrayref){
      $proj[$i]=$$data2[0];
      $i++;

    }
    $sth->finish;
    #write the modification form
    open (FILE,&topinc);
    my @inpu=<FILE>;
    print @inpu;
    close FILE;

    print <<printend
    <form action="/cgi-bin/client.pl" method="POST">
    <table border=0><tr valign=top><td>
    <Table width="100%"><tr><td width="15%">
printend
    ;
    if ($modify ne ''){
      print "<input type=hidden name=type value=update>";
    } else {
      print "<input type=hidden name=type value=insert>";
    }
    print <<printend
    </td>
    <input type=hidden name=num value=$num>
    <td><input type="Submit" name="action" value="Update Record">
    <input type="reset" name="action" value="Clear"> </td></tr>
    <tr>
    <td width="15%"><b>Client Name</b></td>
    <td><input type="Text" name="name" size="20" value="$$data[1]">
    </td>
    </tr>
    <tr>
    <td width="15%"><b>PO Box</b></td>
    <td><input type="Text" name="po_box"  size="20" value="$$data[2]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Street address</b></td>
    <td><input type="Text" name="street" size="20" value="$$data[3]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Suburb </b></td>
    <td><input type="Text" name="suburb"  size="20" value="$$data[4]"></td>
    </tr>
    <tr>
    <td width="15%"><b>City</b></td>
    <td><input type="Text" name="city" size="20" value="$$data[5]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Phone</b></td>
    <td><input type="Text" name="phone" size="20" value="$$data[6]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Fax</b></td>
    <td><input type="Text" name="fax" size="20" value="$$data[7]"></td>
    </tr>
    <tr>
    <td width="15%"><b>URL1</b></td>
    <td><input type="Text" name="url1" size="20" value="$$data[8]"></td>
    </tr>
    <tr>
    <td width="15%"><b>URL2</b></td>
    <td><input type="Text" name="url2" size="20" value="$$data[9]"></td>
    </tr>
    <tr>
    <td width="15%"><b>URL3</b></td>
    <td><input type="Text" name="url3" size="20" value="$$data[10]"></td>
    </tr>
    <tr>
    <td width="15%"><b>URL4</b></td>
    <td><input type="Text" name="url4" size="20" value="$$data[11]"></td>
    </tr>
<!--    <tr>
    <td width="15%"><b>On Mailing list?</b></td>
    <td><input type="radio" name="maillist" size="20" value=1>Yes
    <input type="radio" name="maillist" size="20" value=0 checked>No</td>
    </tr>-->
    </table>
    </td>
    <td>
    <table border=0>
    <tr>
    <td width="15%"><b>Prim Contact</b></td>
    <td><input type="Text" name="c1name" size="20" value="$$data[12]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Phone</b></td>
    <td><input type="Text" name="c1phone" size="20" value="$$data[14]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Alt Phone</b></td>
    <td><input type="Text" name="c1altphone" size="20" value="$$data[15]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Email</b></td>
    <td><input type="Text" name="c1email" size="20" value="$$data[13]"></td>
    </tr>
    <tr><td> &nbsp; </td></tr>
    <tr>
    <td width="15%"><b>Sec Contact</b></td>
    <td><input type="Text" name="c2name" size="20" value="$$data[16]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Phone</b></td>
    <td><input type="Text" name="c2phone" size="20" value="$$data[18]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Alt Phone</b></td>
    <td><input type="Text" name="c2altphone" size="20" value="$$data[19]"></td>
    </tr>
    <tr>
    <td width="15%"><b>Email</b></td>
    <td><input type="Text" name="c2email" size="20" value="$$data[17]"></td>
    </tr>
printend
;
    my $i2=0;
    print "<tr><td><b>Projects</b></td></tr>";
    while ($i2 <= $i){
      $sth=$dbh->prepare("Select * from clientproj where 
      clientname='$$data[1]' and project = '$proj[$i2]'");
      $sth->execute;
      print "<tr><td>&nbsp; </td><td>
     <input type=checkbox name=$proj[$i2] value=$proj[$i2]";
      if (my $data2=$sth->fetchrow_arrayref){
        print " checked";
      }

      $sth->finish;
      print "> $proj[$i2]</td>\n";
      print "</tr>";
      $i2++;
    }
    print <<printend
    </table>
    </td>
    </tr>
    </table>
    </form>

printend
    ;
    
   open (FILE,&botinc);
   my @inpu=<FILE>;
   print @inpu;
   close FILE;
   print "</body></html>";							
  } else {
    my $delete=$query->param('delete.x');
    if ($delete ne ''){
#      print "delete";
#      print $query->dump;
      my $num=$query->param('num');
      my $delquery="Delete from client where recordno = $num";
      my $sth=$dbh->prepare($delquery);
      $sth->execute;
      $sth->finish;
    }
  }
}
if ($check == 0){
my $dispquery="Select * from client order by name";
my $sth=$dbh->prepare($dispquery);
$sth->execute;

open (FILE,&topinc);
my @inpu=<FILE>;
print @inpu;
close FILE;
my $toptab=&toptab;
print "<tr valign=top><td><center>";
print "<font size=6 color=#08004a><em>Clients & Contacts</em></font><p>
<a href=client.pl?Add=add>Add New Client </a><p>
<table cellpadding=4 cellspacing=0 border=0>";
print "<tr valign=top bgcolor=$toptab>
<td><font size=2><b>Client</font></b></td><td><font size=2><b>Primary Contact</b>
</font></td>
<td align=right><font size=2><b>Phone</font></b></td>
<td align=right><font size=2><b>Alt Phone</font></b></td></tr>";
my $switch=0;

while (my $data=$sth->fetchrow_arrayref){
  print "<form action=client.pl method=post>";
  
  print "<tr valign=top";
  if ($switch ==1){
    my $intab=&intab;
    print " bgcolor=$intab";
    $switch=0;
  } else {
    $switch=1;
  }
  print ">
  <td><font size=2><a href=detclient.pl?num=$$data[0]>$$data[1]</font></a></td>
  <td><font size=2><a href=mailto:$$data[13]>$$data[12]</a></font></td>";
  print "<td><font size=2>$$data[14]</font> &nbsp; </td><td><font size=2>$$data[15] &nbsp;</font></td>";
  print "  </tr>";
  print "</form>";
}

print "</table>";
print "</center>";
#print "<a href=/client.html>New Client</a>";

open (FILE,&botinc);
@inpu=<FILE>;
print @inpu;
close FILE;

$sth->finish;
$dbh->disconnect;
print $query->end_html;
}
