#!/usr/bin/perl

#written 4/2/98 by chris@katipo.co.nz
# to create timesheets
# modified 2/3/99 by chris @katipo.co.nz
# to output only work done today
#modified 4/3/99 to use Time::Sheeting;
# modified 17/3/99 to use gloabl include values

use CGI;
use Date::Manip;
use DBI;
use Time::Sheeting;

#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#get database handler;
my $dbh=&TimeConnect;

$query= new CGI;

print "Content-type: text/html\n\n"; 
$user=$query->param('user');
if ($user eq ''){
  $user=$query->param('User');
}
$date=$query->param('date');
$time=$query->param('time');

if ($time eq 'date'){
 $fortnight=$query->param('from');
 $today=$query->param('to');
 $fortnight=&ParseDate($fortnight);
 $today=&ParseDate($today);
 $today2=&outputdate($today);
 $fortnight2=&outputdate($fortnight);
} else {
 $squery="Select max(end),max(start) from pay";
 $sth=$dbh->prepare($squery);
 $sth->execute;
 $data=$sth->fetchrow_arrayref;
 $sth->finish;
 if ($time eq 'current'){
   $today=&ParseDate($$data[0]);
   $today=&DateCalc($today,"in 2 weeks");
   $fortnight=&ParseDate($$data[1]);
   $fortnight=&DateCalc($fortnight,"in 2 weeks");
   $fortnight2=&outputdate($fortnight);
   $today2=&outputdate($today);
 } else {
   if ($time eq 'today'){
     $today=&ParseDate($date);
     $fortnight=$today;
   } else {
     $today=&ParseDate($$data[0]);
     $fortnight=&ParseDate($$data[1]);
   }
   $fortnight2=&outputdate($fortnight);
   $today2=&outputdate($today);
 }
}
$today=&mysql_date($today);
$fortnight=&mysql_date($fortnight);
$squery="Select * from jobs,hours where hours.username = '$user'
and hours.jobno = jobs.jobno and hours.workdate 
>= '$fortnight' and hours.workdate <= 
'$today' order by hours.workdate"; 


$sth=$dbh->prepare($squery);
$sth->execute;

print $query->start_html(-title=>'Time Sheet',-BGCOLOR=>'White');

open (FILE,&topinc);
@inpu=<FILE>;
print @inpu;
close FILE;

print ("<center><h2>Time Sheet for $user from $fortnight2 to $today2</h2>");
#print $squery;
#output times
$total=0;
my $top=&toptab;
print ("<Table border=0 cellspacing=0 cellpadding=4 size=80%> ");
print ("<tr valign=top bgcolor=$top><td><font size=2><B>Date</b></font></td><td>
<font size=2><b>Job</B></font></td>
<td><font size=2><b>Type of work</b></font></td><td><font size=2><b>Description</B></font></td>
<td><font size=2><b>Hours</B></font></td><td colspan=2> &nbsp; </td></tr>\n");
$ref2=$sth->fetchrow_arrayref;
$date=$$ref2[14];
$i=$$ref2[18];
$total=0;
my $checked=0;
my $in=&intab;
while ($ref2){
 print ("<tr valign=top ");
 if ($checked == 1){
   print "bgcolor=$in";
   $checked=0;
 } else {
   $checked=1;
 }
 print "><td>\n";
 print &outputdate($$ref2[14]);
# print $$ref2[14];
 print ("</td><td>");
 print $$ref2[3];
 print ("</td><td align=right>");
 print $$ref2[17];
 print ("</td><td>");
 print $$ref2[16];
 print ("</td><td>");
 print $$ref2[18];
 $temp=$$ref2[18];
 $temp2=$$ref2[12];
 $notes=$$ref2[19];
 $total=$total+$$ref2[18];
 $ref2=$sth->fetchrow_arrayref; 
 if ($ref2){
   if ($date eq $$ref2[14]){
     $i=$i+$$ref2[18];
     print ("</td><td>&nbsp</td>");
     if ($notes ne ''){
       print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
       notes</a></td></tr>";
     }
   } else {
     $date=$$ref2[14];
     print ("</td><td><b>$i</b></td>");
    
     $i=$$ref2[18];
     if ($notes ne ''){
        print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
        notes</a></td></tr>";
        print ("<tr><td>&nbsp</td></tr>");
     } else {
        print ("<tr><td>&nbsp</td></tr>"); 
     }
   }
 } else {
   print ("</td><td><b>$i</b></td>");
   if ($notes ne ''){
     print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
     notes</a></td></tr>";
   }
 }

 print ("\n");


}
print "<tr valign=top bgcolor=$top><td colspan=7> &nbsp; </td></tr>";
print ("</table>");
print ("<p> <h3>The total hours worked are : $total</h3>");
print $query->end_html;

open (FILE,&botinc);
@inpu=<FILE>;
print @inpu;
close FILE;

