#!/usr/bin/perl
#written 1/9/98 by chris@katipo.co.nz
#to insert hours 
#modified bu chris to use Time:Sheeting;

use CGI;
use Date::Manip;
use DBI;
use strict;
use katipo::sql;
use Time::Sheeting;


#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#Set up the DBI and connect to the database
my $dbh=&TimeConnect;
my $query= new CGI;

#get input
my $table=$query->param('table');
if ($table eq 'hours'){
  my @labels = ('code','description','hours','notes','username','jobno','workdate');
  my %input;
  my $user=$query->param('user');
  my $date=$query->param('date');
  my $hours=$query->param('hours');
  my $mins=$query->param('mins');
  #convert hours,min into decimal
  my $time=0;
  $time=$time+$hours+($mins / 60);
  $input{$labels[0]}=$query->param('code');
  $input{$labels[1]}=$query->param('desc');
  $input{$labels[2]}=$time;
  $input{$labels[3]}=$query->param('notes');
  $input{$labels[4]}=$user;
  $input{$labels[5]}=$query->param('jobno');
  $input{$labels[6]}=$date;
  &sql_ins(\%input,$dbh,$table);
  my $temp="/cgi-bin/timesheet2.pl?user=".$user."&date=".$date;
  print $query->redirect($temp);
}
if ($table eq 'jobs'){
   for (my $i=1; $i<4; $i++){
    my %input;
    my @labels =('recordno','jobno','jobcode','description','openedby','estimated','dateopened','project','notes');
    $input{$labels[0]}=$query->param('recordno'.$i);
    $input{$labels[1]}=$query->param('jobno'.$i);
    $input{$labels[7]}=$query->param('project'.$i);
    $input{$labels[2]}=$query->param('description'.$i);
    $input{$labels[3]}=$query->param('description'.$i);
    $input{$labels[4]}=$query->param('openedby'.$i);
    $input{$labels[5]}=$query->param('estimate'.$i);
    $input{$labels[8]}=$query->param('notes'.$i);
    $input{$labels[6]}="now()";
#    print $query->header;
#    print $query->dump;
    if ($input{$labels[2]} ne ''){
#      print "$i insert";
      &sql_ins(\%input,$dbh,$table);
      my $jobno=$query->param('jobno'.$i);
      my $select="select username from staff";
      my $sth=$dbh->prepare($select);
      $sth->execute;
      while (my $dat =$sth->fetchrow_arrayref){
        if ($query->param($$dat[0]) ne '') {
          my $sth2=$dbh->prepare("Insert into customjob values ('$$dat[0]',$jobno)");
          $sth2->execute;
          $sth2->finish;
        }
      }
      $sth->finish;
    }
   }
   my $temp="/cgi-bin/jobs2.pl";
   print $query->redirect($temp);
}
if ($table eq 'project'){
 # print $query->header;
 # print $query->dump;
  my @labels=('name','quote1','quote2','quote3','notes','openedby');
  my %input;
  $input{$labels[0]}=$query->param('project name');
  $input{$labels[1]}=$query->param('quote-url-1');
  $input{$labels[2]}=$query->param('quote-url-2');
  $input{$labels[3]}=$query->param('quote-url-3');
  $input{$labels[4]}=$query->param('notes');
  $input{$labels[5]}=$query->param('openedby');
  my $client=$query->param('client');
   &sql_ins(\%input,$dbh,$table);  
  @labels=('clientname','project');
  my %inp2;
  $inp2{$labels[0]}=$client;
  $inp2{$labels[1]}=$query->param('project name');
  &sql_ins(\%inp2,$dbh,"clientproj");
  my $project=$query->param('project name');
  $project=~ s/ /%20/g;
  my $temp="/cgi-bin/modjobs.pl?type=add&project=$project";
   print $query->redirect($temp);  
}
$dbh->disconnect;
