#!/usr/bin/perl

#modified 16.3.99 by chris@katipo.co.nz
#script to set out invoicing information
#called from projinv.pl
#calls inturn invoice.pl to do the invoice data insert

use DBI;
use CGI;
use Time::Sheeting;

$input=new CGI;

$dbh=&TimeConnect;

$jobs=$input->param('Job');

$query = "Select jobs.description,jobs.dateinvoiced,jobs.estimated,
sum(hours.hours),jobs.invoiced
from jobs,hours where jobs.jobno=$jobs and hours.jobno=$jobs";
$sth=$dbh->prepare($query);
$sth->execute;
$data=$sth->fetchrow_arrayref;
print $input->header;
#print $query;
print <<printend
<html>

<head>
<TITLE>Katipo: Invoicing</TITLE>
<SCRIPT LANGUAGE="JavaScript">
var total,charge;
total=0;
charge=0;
// go to page selected from options menu

function calculate(hours,value) {
total=total+hours;
charge=charge+(hours*value);
document.calc.hoursinvd.value=total;
document.calc.charge.value=charge;
}

function subtract(hours,value){
total=total-hours;
charge=charge-(hours*value);
document.calc.hoursinvd.value=total;
document.calc.charge.value=charge;
}
        //
	</script>
</head>
printend
;
open (FILE,&topinc);
@inpu=<FILE>;
print @inpu;
close FILE;

    my $intab=&intab;
print <<printend


<blockquote><center>
<font size="6" color="#08004a"><em>invoicing: summary for $$data[0]</em> </font><p>


<table cellpadding=5 cellspacing=0 border=0>

<tr><td colspan=8>

<table cellpadding=5 cellspacing=0 border=0 width="100%">
<tr><td colspan=2  bgcolor="$intab">
<font size=2 face=arial>Last Invoiced: $$data[1]</FONT></TD>
<td colspan=2  bgcolor="$intab">
 &nbsp; </td></tr>


<tr valign=top>
<td bgcolor="$intab"> <font size=2 face=arial><a href="modjobs.pl?job=$jobs&type=mod">Estimated: $$data[2]</a></font></td>
<td  bgcolor="$intab"><font size=2 face=arial>Worked: $$data[3]</font></td>
<td  bgcolor="$intab"><font size=2 face=arial>Invoiced to date: $$data[4]</font></td>
<td  bgcolor="$intab"><font size=2 face=arial><b>To be invoiced: 
printend
;
my $sth4=$dbh->prepare("Select sum(hours) from hours where invoiced=2 and jobno=$jobs");
$sth4->execute;
my $data3=$sth4->fetchrow_arrayref;
$sth4->finish;

my $todo=$$data[4]-$$data[3]+$$data3[0];
if ($todo < 0){
  $todo=$todo*-1;
  print "<font color=red>";
}
my $toptab=&toptab;
my $abovetab=&abovetab;
print <<printend
$todo</td>

<tr>
</table>
</td></tr>
<tr valign=middle>
<td colspan=8 align=right>
<table cellspacing=0 cellpadding=5 border=0>
<form name=calc><input type=hidden name=type value=update>
<input type=hidden name=Job value="$jobs">
<input type=hidden name=date value=1998-10-30>
<tr valign=top><td  bgcolor=$abovetab>
<font size=2 face=arial>Quick Calculator: 
<input type=text size=6 name=hoursinvd>hrs </font></td>
<td bgcolor=$abovetab><font size=2> = \$ <input type=text size=6 name=charge></tr>
</form>
</table>

</td></tr>


<TR VALIGN=TOP><TD  COLSPAN=7><img src="/images/holder.gif"  WIDTH=1  HEIGHT=1></TD></TR>



<tr valign=top>
<tr valign=top><td bgcolor=$toptab ><font size=2><b>Date</b></font></td>
<td bgcolor=$toptab><font size=2><b>Worker</b></font></td>
<td bgcolor=$toptab><font size=2><b>Description</b></font></td>
<td bgcolor=$toptab><font size=2><b>Charge Rate</b></font></td>
<td bgcolor=$toptab><font size=2><b>Hours</b></font></td>
<td bgcolor=$toptab><font size=2><b>Invoiced</b></font></td>
</tr>
printend
;
print "<form action=invoice.pl method=post>";
$sth2=$dbh->prepare("Select * from hours where jobno=$jobs and
(invoiced <> 1 and invoiced <> 2 or invoiced is NULL)");
$sth2->execute;
my $i=1;
while (my $data2=$sth2->fetchrow_arrayref){
  print "<tr valign=top ";
  if ($switch ==0){

    print "bgcolor=$intab";
    $switch=1;
  } else {
    $switch=0;
  }
  print ">";


    print "<td ><font size=2>$$data2[2]</font></td>
    <td ><font size=2>";

      print $$data2[3];

    print "</font></td>
    <td><font size=2>$$data2[4]</font></td>";
    print "<td><font size=2>$$data2[5]</font></td>";
    print "<td><font size=2>$$data2[6]</font></td>";
#        print "<td><font size=2>$$data2[8]</font></td>";
    print "<td><input type=radio name=inv$i value=1";
    if ($$data2[8] eq '1'){
      print " checked";
    }
    print " onclick=\"calculate($$data2[6],$$data2[5])\"> <input type=radio name=inv$i value=2";
    if ($$data2[8] eq '2'){
      print " checked";
    }
    print " onclick=\"subtract($$data2[6],$$data2[5])\"";
    print "><font size=2>N/A</font> <input type=radio name=inv$i value=3";
    if ($$data2[8] eq '3' || $$data2[8] eq ''){
      print " checked";
    }
    print " onclick=\"subtract($$data2[6],$$data2[5])\"";
    print "> <font size=2>Later </font></td>";
    print "<input type=hidden name=hour$i value=$$data2[6]>\n
    <input type=hidden name=Job value=$jobs><input type=hidden name=record$i value=$$data2[0]>";
  print "</tr>";
$i++;    

}


print <<printend

<tr valign=top>
<tr valign=top><td colspan=4 bgcolor=$toptab><font size=2><b> &nbsp;</b></font></td>
<td bgcolor=$toptab ALIGN=RIGHT ><font size=2><b><input type=reset
value="Clear checked items">
</b></font></td>
<td bgcolor=$toptab ALIGN=RIGHT ><font size=2><b><input type=submit
value="Record Invoice"></b></font></td>

</tr>
</table>

<!--<p>
<a href=jobs.pl?Jobs=W4-Source&job=job>Project Summary</a> &nbsp; | &nbsp;
<a href=jobs.pl?Jobs=W4-Source&job=job>Job History</a> &nbsp; | &nbsp;
<a href=jobs.pl?Jobs=W4-Source&job=job>Job Card</a> &nbsp; | &nbsp;
<a href=jobs.pl?Jobs=W4-Source&job=job>Client Record</a>
-->

</CENTER></BLOCKQUOTE>

printend
;

open (FILE,&botinc);
@inpu=<FILE>;
print @inpu;
close FILE;

print <<printend

</body></html>


printend
;
