package katipo::sql; #asummes katipo/sql.pm

#written 10/3/99 by chris@katipo.co.nz

#requires DBI.pm to be installed
#required Date::Manip
use strict;
require Exporter;
use DBI;
use Date::Manip;

use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
  
# set the version for version checking
$VERSION = 0.01;
    
@ISA = qw(Exporter);
@EXPORT = qw( &sql_ins &sql_up);
%EXPORT_TAGS = ( );     # eg: TAG => [ qw!name1 name2! ],
		  
# your exported package globals go here,
# as well as any optionally exported functions

@EXPORT_OK   = qw($Var1 %Hashit);


# non-exported package globals go here
use vars qw(@more $stuff);
	
# initalize package globals, first exported ones

my $Var1   = '';
my %Hashit = ();
		    
# then the others (which are still accessible as $Some::Module::stuff)
my $stuff  = '';
my @more   = ();
	
# all file-scoped lexicals must be created before
# the functions below that use them.
		
# file-private lexicals go here
my $priv_var    = '';
my %secret_hash = ();
			    
# here's a file-private function as a closure,
# callable as &$priv_func;  it cannot be prototyped.

my $priv_func = sub {
  # stuff goes here.
};
						    
# make all your functions, whether exported or not;

sub sql_ins {
 my $input=$_[0];
 my $dbh=$_[1];
 my $table=$_[2];
 my $i;
 my $query="insert into $table (";
 while ($i=each %$input){
   $query=$query." $i,";
   
 }
  $query=~ s/,$/)/;
 $query=$query." values (";
 while ($i =each %$input){
   if ($input->{$i} =~ /[a-z]|\$|\-/i){
     $input->{$i}=~ s/\'/\\\'/g;
     if ($input->{$i} eq 'now()'){
       $query=$query." now(), ";
     }else{
     $query=$query." '$input->{$i}',";
     }
   } else {
    if ($input->{$i} eq ''){
      $input->{$i} = 'NULL';
    }
    $query=$query." $input->{$i},";
   }
 }
 $query=~ s/,$/)/;
# print $query;
 my $sth=$dbh->prepare($query);
 $sth->execute;
 $sth->finish;
}

sub sql_up {
 my $input=$_[0];
 my $dbh=$_[1];
 my $table=$_[2];
 my $where=$_[3];
 my $i;
 my $query="update $table set";
 while ($i=each %$input){
   $query=$query." $i=";
   if ($input->{$i} =~ /[a-z]|\$|\-| /i){
     $input->{$i}=~ s/\'/\\\'/g;
     $query=$query." '$input->{$i}',";
   } else {
    if ($input->{$i} eq ''){
      $input->{$i} = 'NULL';
    }
    $query=$query." $input->{$i},";
   }
 }
 $query=~ s/,$/ /;
 $query=$query.$where;
# print $query;
 my $sth=$dbh->prepare($query);
 $sth->execute;
 $sth->finish;
}
END { }       # module clean-up code here (global destructor)
