#!/usr/bin/perl

#written 4/2/98 by chris@katipo.co.nz
# to create job reports
#modified 16.3.99
#to use Time::Sheeting

use CGI;
use Date::Manip;
use DBI;
use Time::Sheeting;
use strict;
#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#Set up the DBI and connect to the database
my $dbh=&TimeConnect;
my $query= new CGI;

my $jobs=$query->param('Jobs');
my $user=$query->param('User');
my $projects=$query->param('Projects');
my $code=$query->param('code');
my $date=$query->param('date');
my $edate=$query->param('edate');
my $sdate=$query->param('sdate');
print $query->header;
print $query->dump;

my $squery="Select * from hours,jobs where hours.jobno=jobs.jobno";
if ($jobs ne 'All Jobs'){
  $squery=$squery." and jobs.description='$jobs'";
}
if ($user ne 'All Users'){
  $squery=$squery." and hours.username='$user'";
}
if ($code ne ''){
  $squery=$squery." and hours.code='$code'";
}
if ($projects ne 'All Projects'){
  $squery=$squery." and jobs.project = '$projects'";
}
if ($sdate ne ''){
  $sdate=&ParseDate($sdate);
  $sdate=&mysql_date($sdate);
  $squery=$squery." and hours.workdate >='$sdate'";
}
if ($edate ne ''){
  $edate=&ParseDate($edate);
  $edate=&mysql_date($edate);
  $squery=$squery." and hours.workdate <='$edate'";
}
$squery=$squery." order by hours.jobno,hours.workdate";
print $squery;
my $sth=$dbh->prepare($squery);
$sth->execute;
print "<table><tr valign=top><td>Job</td><td>Date</td><td>User</td><td>Description</td>
<td>Code</td><td>Hours</td></tr>";
my $hours=0;
while (my $data=$sth->fetchrow_arrayref){
  print "<tr valign=top><td>$$data[12]</td>
  <td>$$data[2]</td><td>$$data[3]</td><td>$$data[4]</td>
  <td>$$data[5]</td><td>$$data[6]</td></tr>";
  $hours=$hours+$$data[6];

}
print "<tr valign=top><td colspan=5> &nbsp; </td><td>$hours</td></tr>";
print "</table>";
$sth->finish;
$dbh->disconnect;
