#!/usr/bin/perl

#written 4/2/98 by chris@katipo.co.nz
# to create timesheets

#updated 17/3/99 by chris
# to use Time::Sheeting

use CGI;
use Date::Manip;
use DBI;
use Time::Sheeting;

#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#Set up the DBI and connect to the database
$dbh=&topinc;
$query= new CGI;

print "Content-type: text/html\n\n"; 
$user=$query->param('user');
if ($user eq ''){
  $user=$query->param('User');
}
$time=$query->param('time');

if ($time eq 'date'){
 $fortnight=$query->param('from');
 $today=$query->param('to');
 $fortnight=&ParseDate($fortnight);
 $today=&ParseDate($today);
 $today2=&fixdate($today);
 $fortnight2=&fixdate($fortnight);
} else {
 $squery="Select max(end),max(start) from pay";
 $sth=$dbh->prepare($squery);
 $sth->execute;
 $data=$sth->fetchrow_arrayref;
 $sth->finish;
 if ($time eq 'current'){
   $today=&ParseDate($$data[0]);
   $today=&DateCalc($today,"in 2 weeks");
   $fortnight=&ParseDate($$data[1]);
   $fortnight=&DateCalc($fortnight,"in 2 weeks");
   $fortnight2=&fixdate($fortnight);
   $today2=&fixdate($today);
 } else {
   $today=&ParseDate($$data[0]);
   $fortnight=&ParseDate($$data[1]);
   $fortnight2=&fixdate($fortnight);
   $today2=&fixdate($today);
 }
}
$today=substr($today,0,8);
$fortnight=substr($fortnight,0,8);
$squery="Select * from jobs,hours where hours.username = '$user'
and hours.jobno = jobs.jobno and hours.workdate 
>= '$fortnight' and hours.workdate <= 
'$today' order by hours.workdate"; 


$sth=$dbh->prepare($squery);
$sth->execute;

print $query->start_html(-title=>'Time Sheet',-BGCOLOR=>'White');

print ("<center><h2>Time Sheet for $user from $fortnight2 to $today2</h2></center>");
#print $squery;
#output times
$total=0;
print ("<Table border=0 cellspacing=2 cellpadding=2>");
print ("<tr valign=top><td><B>Date</b></td><td><b>Job</B></td>
<td><b>Type of work</b></td><td><b>Description</B></td><td><b>Hours</B></td></tr>\n");
$ref2=$sth->fetchrow_arrayref;
$date=$$ref2[13];
$i=$$ref2[17];
$total=0;
while ($ref2){
 print ("<tr valign=top><td>\n");
 print &fixdate2($$ref2[13]);
 print ("</td><td>");
 print $$ref2[3];
 print ("</td><td>");
 print $$ref2[16];
 print ("</td><td>");
 print $$ref2[15];
 print ("</td><td>");
 print $$ref2[17];
 $temp=$$ref2[17];
 $temp2=$$ref2[11];
 $notes=$$ref2[18];
 $total=$total+$$ref2[17];
 $ref2=$sth->fetchrow_arrayref; 
 if ($ref2){
   if ($date eq $$ref2[13]){
     $i=$i+$$ref2[17];
     print ("</td><td>&nbsp</td>");
     if ($notes ne ''){
       print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
       notes</a></td></tr>";
     }
   } else {
     $date=$$ref2[13];
     print ("</td><td><b>$i</b></td>");
    
     $i=$$ref2[17];
     if ($notes ne ''){
        print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
        notes</a></td></tr>";
        print ("<tr><td>&nbsp</td></tr>");
     } else {
        print ("<tr><td>&nbsp</td></tr>"); 
     }
   }
 } else {
   print ("</td><td><b>$i</b></td>");
   if ($notes ne ''){
     print "<td><a href=/cgi-bin/notes.pl?recordno=$temp2>
     notes</a></td></tr>";
   }
 }

 print ("\n");


}

print ("</table>");
print ("<p> <h3>The total hours worked are : $total</h3>");
print $query->end_html;


sub fixdate {
  local @temp=@_;
  local $year=substr(@temp[0],0,4);
  local $month=substr(@temp[0],4,2);
  local $day=substr(@temp[0],6,2);
  local $temp=$day."/".$month."/".$year;
  return ($temp);
}
sub fixdate2 {
  local @temp=@_;
  local $year=substr(@temp[0],2,2);
  local $month=substr(@temp[0],5,2);
  local $day=substr(@temp[0],8,2);
  local $temp=$day."/".$month."/".$year;
  return ($temp);
}
