#!/usr/bin/perl

#written 4/7/98 by chris@katipo.co.nz
# to create timesheet summaries
#updated 7/8/98 by chris
#modified 5/3/98 by chris
#to use Time::Sheeting and an option to do last weeks pay
#modified 17.3.99 by chris to use global variables
#modified 8/6/99 
# modified 12/7/99

use CGI;
use Date::Manip;
use DBI;
use Mail::Sendmail;
use Time::Sheeting;

#Set up, set the date formatting.
&Date_Init("DateFormat=nonUS");

#Set up the DBI and connect to the database
$dbh=&TimeConnect;
$query= new CGI;

my $sth=$dbh->prepare("select * from admin where username=$user2");
$sth->execute;
my @admin=$sth->fetchrow_array;
$sth->finish;


print $query->header;
print <<printend
<html>

<head>
<TITLE>Katipo: PaySummary</TITLE>

</head>
printend
;
open (FILE,&topinc);
@inpu=<FILE>;
print @inpu;
close FILE;

$send=$query->param('send');
if ($send eq ''){
  $user=$query->param('User');
  $time=$query->param('time');
  if ($time eq 'year'){
    $today=20000331;
    $fortnight=19990401;
  } else {
    if ($time eq 'month'){
      $to=$query->param('to');
      $from=$query->param('from');
      $today=&ParseDate($to);
      $fortnight=&ParseDate($from);
      open (FILE,">> /usr/local/www/ts/htdocs/paye.html");
    } else {  
      $squery="Select max(end),max(start) from pay";
      $sth=$dbh->prepare($squery);
      $sth->execute;
      $data=$sth->fetchrow_arrayref;
      $sth->finish;            
      $today=&ParseDate($$data[0]);
      $fortnight=&ParseDate($$data[1]);
      if ($time ne 'last'){
        $weeks = &ParseDateDelta('in 2 weeks');
        $today=&DateCalc($today,$weeks);
        $fortnight=&DateCalc($fortnight,$weeks);
      }
    }
  }
  $fortnight2=&outputdate($fortnight);
  $today2=&outputdate($today);
  $fortnight=&mysql_date($fortnight,"%Y%m%e");
  $today=&mysql_date($today,"%Y%m%e");
  if ($time eq 'month'){
    $squery="Select sum(paye),user,sum(gross),sum(net) from pay where start >= '$fortnight'
    and end <= '$today' group by user";
  } else {
    $squery="Select sum(hours),username from hours where
    workdate >= '$fortnight' and workdate <= '$today' group by username"; 
  }
  $sth=$dbh->prepare($squery);
  $sth->execute;
  print ("<center><h2>pay summary : $fortnight2 to $today2</h2>");
  #output times
  $total=0;
  print ("<Table border=0 cellspacing=0 cellpadding=4>");
  print "<form action=/cgi-bin/paysummary.pl method=post>";
  my $toptab=&toptab;
  print ("<tr valign=top bgcolor=$toptab>
  <td><font size=2><B>Name</b></td>
  <td><font size=2><b>Hours</B></td>
  <td><font size=2><b>Rate</b></td>
  <td><font size=2><b>Gross</B></td>
  <td><font size=2><b>PAYE</B></td>
  <td><font size=2><b>Student Loan</b></td>
  <td><font size=2><b>Net</b></td>
  <td><font size=2> <input type=submit name=calculate  value=calculate></tr>\n");
  print "<input type=hidden name=time value=$time>";
  $ref2=$sth->fetchrow_arrayref;

  print "<input type=hidden name=start value=$fortnight2>
  <input type=hidden name=end value=$today2>";
  $i=0;
  my $in=&intab;
  my $checked=0;
  while ($ref2){
   $gross=0;
   $paye=0;
   $net=0;
   my $user=$query->remote_user;
   if ($admin[0] == 1 || $$ref2[1] eq $user){
    print ("<tr valign=top ");
    if ($checked==1){
     print "bgcolor=$in";
     $checked=0;
    } else {
     $checked=1;
    }
    print ("><td><font size=2><a href=fortnights.pl?user=$$ref2[1]&time=current>
    $$ref2[1]</a></td>\n");
    $sth4=$dbh->prepare("Select payrate from staff where username='$$ref2[1]'");
    $sth4->execute;
    $payrate=$sth4->fetchrow_arrayref;
    $sth4->finish;
    $rate=$$payrate[0];
    if ($time eq 'month'){
     $gross=$$ref2[2];
     $paye=$$ref2[0];
     $net=$$ref2[3];
    } else {
     $gross=$rate * $$ref2[0];
     $paye=$query->param($$ref2[1]);
     $loan=$query->param($$ref2[1].'l');
     $net= $gross - $paye - $loan;
     
    }
    $tgross=$tgross+$gross;
    $tpaye=$tpaye+$paye;
    $tnet=$tnet+$net;
    $tstloan=$tstloan+$loan;
    $temp=$$ref2[1].'hours';
    if ($time ne 'month'){
     print "<td><font size=2><input type=hidden name=$temp value=$$ref2[0]>",$$ref2[0],"</td>";
    } else {
     print "<td> &nbsp; </td>";
    }
    $temp=$$ref2[1].'gross';
    print "<td><font size=2>$rate</td>";
    print "<td><font size=2><input type=hidden name=$temp value=$gross>
    $gross</td>";
    $temp=$query->param($$ref2[1]);
    $temp2=$query->param($$ref2[1].'l');
    if ($time eq 'month'){
     print FILE "$$ref2[1] $gross $paye $net <br>";
     print "<td><font size=2>$paye</td><td><font size=2>$loan</td>";
    } else {
     $ltemp=$$ref2[1].'l';
     print "<td><font size=2><input name=$$ref2[1] size=6 value=$temp></td>
     <td><font size=2><input name=$ltemp size=6 value=$temp2></td>";
    }
    $temp=$$ref2[1].'paye';
    print "<input name=$temp type=hidden value=$paye>";
    $temp=$$ref2[1].'loan';
    print "<input name=$temp type=hidden value=$loan>";
    $temp=$$ref2[1].'net';
    print "<td><font size=2><input name=$temp type=hidden value=$net>
    $net</td>"; 
    $temp='Send-'.$$ref2[1];
    print "<td><font size=2><input type=submit name=send value=$temp></td>";
    print "</tr>";
   }
   $ref2=$sth->fetchrow_arrayref; 

   print ("\n");
   $i++;

  }
  print <<printend
  <tr valign=top bgcolor=$toptab >
  <td><FONT SIZE=2><B>Total:</b></td>
  <td><FONT SIZE=2><b>&nbsp;</B></td>
  <td><FONT SIZE=2><b>&nbsp;</b></td>
  <td><FONT SIZE=2><b>\$$tgross</B></td>
  <td><FONT SIZE=2><b>\$$tpaye</B></td>
  <td><Font size=2><b>\$$tstloan</b></td>
  <td><FONT SIZE=2><b>\$$tnet</b></td>
  
  <td><FONT SIZE=2><b>&nbsp;</b></td></tr>
  </table></form>

  <a href=paysummary.pl?time=year>Yearly PAYE Summary</a>
<br>
  <a href=paysummary.pl?time=last>Last fortnights</a>
<br>
<form method=post action=paysummary.pl>
<input type=hidden name=time value=month>
<input type=text name=from size=10 value=$from>
<input type=text name=to size=10 value=$to> <input type=submit value=Summary>
</form>

  </CENTER></BLOCKQUOTE>
  
printend
;
open (FILE,&botinc);
@inpu=<FILE>;
print @inpu;
close FILE;

$sth->finish;

close FILE;
} else {
  $send=~ s/Send-//g;
  $hours=$query->param($send.'hours');
  $gross=$query->param($send.'gross');
  $paye=$query->param($send.'paye');
  $loan=$query->param($send.'loan');
  $net=$query->param($send.'net');
  $start=$query->param('start');
  $end=$query->param('end');
  my $sth=$dbh->prepare("Select email from staff where username='$send'");
  $sth->execute;
  my @email=$sth->fetchrow_array;
  $sth->finish;  
  ######################################################################################
  # modify rachel@katipo.co.nz to tbe the email address of your timesheet administrator#
  ######################################################################################
  %mail = ( To      => $email[0],
  CC => 'rachel@katipo.co.nz',
  From    => 'rachel@katipo.co.nz',
  Subject => 'Pay for '.$start.' to '.$end,
  Message => "You have been paid,
  Pay period from $start to $end
  
  Hours worked : $hours
  Gross pay: $gross
  Tax : $paye
  Loan: $loan
  Net pay : $net
  "
  
  );
  if (sendmail %mail) { print "Mail sent to $send OK.\n" }
  else { print "Error sending mail: $Mail::Sendmail::error \n" }

  #insert data into pay table
  $start=&mysql_date($start);
  $end=&mysql_date($end);

  $sth=$dbh->prepare("Insert into pay values ('$send',now(),'$start',
  '$end','$paye','$gross','$net','$loan')");
  $sth->execute;
  $sth->finish;
  open (FILE,"/usr/local/www/ts/htdocs/includes/time_bottom.inc");
  @inpu=<FILE>;
  print @inpu;
  close FILE;
  
}
$dbh->disconnect;
